% early_kickout 
%
%       Francesc Moreno-Noguer, Vincent Lepetit, Pascal Fua
%       Pose Priors for Simultaneously Solving Alignment and Correspondence
%       European Conference on Computer Vision (ECCV), 2008
%
% Copyright (C) <2009>  <Francesc Moreno-Noguer, Vincent Lepetit, Pascal Fua>
% 
% This program is free software: you can redistribute it and/or modify
% it under the terms of the version 3 of the GNU General Public License
% as published by the Free Software Foundation.
% 
% This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
% General Public License for more details.       
% You should have received a copy of the GNU General Public License
% along with this program. If not, see <http://www.gnu.org/licenses/>.
%
% Francesc Moreno-Noguer, Institut de Robtica i Informtica Industrial (CSIC/UPC), May 2009.
% fmoreno@iri.upc.edu, http://www-iri.upc.es/people/fmoreno/

function ek=early_kickout(tree,Prob_outliers,KICKOUT_THRESHOLD)

last_node=tree.node(end);
num_outliers=tree.nancestors(last_node)-tree.nvalid_ancestors(last_node);
depth_node=tree.depth(last_node);


if depth_node>5
    %Probability of this number of outliers
    P=Prob_outliers(depth_node).P(num_outliers);
    if P<KICKOUT_THRESHOLD
        ek=1;
    else
        ek=0;
    end
else
    ek=0; %do not kickout if depth_node<5
end
    
    
    