% mahalanobis_distance 
%
%       Francesc Moreno-Noguer, Vincent Lepetit, Pascal Fua
%       Pose Priors for Simultaneously Solving Alignment and Correspondence
%       European Conference on Computer Vision (ECCV), 2008
%
% Copyright (C) <2009>  <Francesc Moreno-Noguer, Vincent Lepetit, Pascal Fua>
% 
% This program is free software: you can redistribute it and/or modify
% it under the terms of the version 3 of the GNU General Public License
% as published by the Free Software Foundation.
% 
% This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
% General Public License for more details.       
% You should have received a copy of the GNU General Public License
% along with this program. If not, see <http://www.gnu.org/licenses/>.
%
% Francesc Moreno-Noguer, Institut de Robtica i Informtica Industrial (CSIC/UPC), May 2009.
% fmoreno@iri.upc.edu, http://www-iri.upc.es/people/fmoreno/

function dist_mah=mahalanobis_distance(x,y,cov)

inv_cov=inverse_matrix(cov);
x_y=x-y;
x_y=x_y';

dist_mah=sqrt(x_y'*inv_cov*x_y);




function B=inverse_matrix(A)

a=A(1,1); b=A(1,2);
c=A(2,1); d=A(2,2);

t4 = 0.1e1 / (a * d - b * c);
B(1,1) = d * t4;
B(1,2) = -b * t4;
B(2,1) = -c * t4;
B(2,2) = a * t4;
