% nonrepeated 
%
%       Francesc Moreno-Noguer, Vincent Lepetit, Pascal Fua
%       Pose Priors for Simultaneously Solving Alignment and Correspondence
%       European Conference on Computer Vision (ECCV), 2008
%
% Copyright (C) <2009>  <Francesc Moreno-Noguer, Vincent Lepetit, Pascal Fua>
% 
% This program is free software: you can redistribute it and/or modify
% it under the terms of the version 3 of the GNU General Public License
% as published by the Free Software Foundation.
% 
% This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
% General Public License for more details.       
% You should have received a copy of the GNU General Public License
% along with this program. If not, see <http://www.gnu.org/licenses/>.
%
% Francesc Moreno-Noguer, Institut de Robtica i Informtica Industrial (CSIC/UPC), May 2009.
% fmoreno@iri.upc.edu, http://www-iri.upc.es/people/fmoreno/

function [idxnonrepeated,idxrepeated,nrep,allidxrepeated]=nonrepeated(x) 


npoints=max(size(x));

idxnonrepeated=[];
idxrepeated=[];
nrep=[];
allidxrepeated=[];
nonconsidered=ones(size(x));
cont=1;
cont_rep=1;
for i=1:npoints
    if nonconsidered(i)
        xi=x(i);
        pxi=find(x==xi & nonconsidered);
        nr=size(pxi,2);
        nonconsidered(pxi)=0;
        if nr==1 %if the point is repeated, do not appear in the list of indices
        idxnonrepeated(cont)=i;
        cont=cont+1;
        else
            idxrepeated(cont_rep)=pxi(1);      
            nrep(cont_rep)=nr;
            allidxrepeated=[allidxrepeated,pxi];
			cont_rep=cont_rep+1;
        end
    end
end