% compute_all_errors 
%
%       Francesc Moreno-Noguer, Vincent Lepetit, Pascal Fua
%       Pose Priors for Simultaneously Solving Alignment and Correspondence
%       European Conference on Computer Vision (ECCV), 2008
%
% Copyright (C) <2009>  <Francesc Moreno-Noguer, Vincent Lepetit, Pascal Fua>
% 
% This program is free software: you can redistribute it and/or modify
% it under the terms of the version 3 of the GNU General Public License
% as published by the Free Software Foundation.
% 
% This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
% General Public License for more details.       
% You should have received a copy of the GNU General Public License
% along with this program. If not, see <http://www.gnu.org/licenses/>.
%
% Francesc Moreno-Noguer, Institut de Robtica i Informtica Industrial (CSIC/UPC), May 2009.
% fmoreno@iri.upc.edu, http://www-iri.upc.es/people/fmoreno/

function [error_rep_true,error_rep_est,error_rot,error_trans]=compute_all_errors(Xw_match,U_match,Xw_true,Utrue,R,T,A,Rtrue,Ttrue)

%reprojection error
[error_rep_true,Urep_true]=reprojection_error_usingRT(Xw_true,Utrue,Rtrue,Ttrue,A);
[error_rep_est,Urep_est]=reprojection_error_usingRT(Xw_match,U_match,R,T,A);

%translation error
error_trans=100*norm(Ttrue-T)/norm(Ttrue);

%rotation error (two possible solutions for the quaternion)
qtrue=rot_to_quaternion(Rtrue);
qest=rot_to_quaternion(R);
  
error_rot1=norm(qtrue-qest)/norm(qtrue);
error_rot2=norm(qtrue+qest)/norm(qtrue);
error_rot=100*min(error_rot1,error_rot2);

