% generate_3D_model 
%
%       Francesc Moreno-Noguer, Vincent Lepetit, Pascal Fua
%       Pose Priors for Simultaneously Solving Alignment and Correspondence
%       European Conference on Computer Vision (ECCV), 2008
%
% Copyright (C) <2009>  <Francesc Moreno-Noguer, Vincent Lepetit, Pascal Fua>
% 
% This program is free software: you can redistribute it and/or modify
% it under the terms of the version 3 of the GNU General Public License
% as published by the Free Software Foundation.
% 
% This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
% General Public License for more details.       
% You should have received a copy of the GNU General Public License
% along with this program. If not, see <http://www.gnu.org/licenses/>.
%
% Francesc Moreno-Noguer, Institut de Robtica i Informtica Industrial (CSIC/UPC), May 2009.
% fmoreno@iri.upc.edu, http://www-iri.upc.es/people/fmoreno/

function  Xw=generate_3D_model(n)

%true 3d position of the points--------------
xini=-1; xend=1;%bounds 
yini=-1; yend=1;
zini=-1; zend=1;


i=1;
for i=1:n
    Xw(i,1)=random(xini,xend,1);
    Xw(i,2)=random(yini,yend,1);
    Xw(i,3)=random(zini,zend,1);
end

%Center the model points
Cw=mean(Xw);
Xw=Xw-repmat(Cw,[n,1]);


